package com.nokia.finance.tasks.dao.gdc.house;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Update;

@Mapper
public interface GdcHouseProcedureDao {
    /**
     * 更新自有房产维修
     */
    @Update("""
with
t101 as (
select * from house.building_month where year_month = (select max(year_month) from house.building_month)
)
insert into house_theme.wz_f_housermaintenance_maintenance_cost_detailed (
     building_id,
     repair_type,
     repair_content,
     erp_credited_amount,
     province,
     city,
     county,
     building_address_number,
     building_name_alias,
     standard_address,
     city_grade,
     city_area,
     district,
     land_assets,
     building_address_id,
     building_alias,
     building_rate,
     building_source,
     getdate,
     building_startyear,
     investment_entity,
     management_hierarchy,
     building_structure,
     total_number_of_floors,
     asset_code,
     asts_labe,
     use_state,
     building_use,
     ownership_status,
     building_floor_area,
     building_area,
     building_area_use_area,
     building_area_rent_area,
     building_area_idel_area,
     building_area_unavailable,
     use_area,
     use_area_self_use_area,
     use_area_rent_area,
     use_area_idel_area,
     use_area_unavailable_area,
     statistical_month
)
select
     t1.jz_jzid,
     t1.repair_type,
     t1.content_category,
     t1.final_cost,
     '河北',
     t1.area_name,
     t1.city_name,
     t2.site_num,
     t2.site_name,
     t2.address,
     t2.city_level,
     t2.city_region,
     t2.area_sector,
     t2.has_land,
     t2.site_id,
     t2.building_name,
     t2.housing_acquisition_rate,
     t2.housing_source,
     t2.acquisition_date,
     t2.house_year_began,
     t2.investor,
     t2.management_level,
     t2.building_structure,
     t2.total_floors,
     t2.assets_num,
     t2.assets_tag_num,
     t2.usage_status,
     t2.building_use,
     t2.ownership_status,
     t2.floor_area,
     t2.building_area,
     t2.building_area_self_use,
     t2.building_area_rent,
     t2.building_area_idle,
     t2.building_area_unusable,
     t2.usable_area,
     t2.usable_area_self_use,
     t2.usable_area_rent,
     t2.usable_area_idle,
     t2.usable_area_unusable,
     t1.year_month
from house.building_repair_month t1 left join t101 t2 on t1.jz_jzid = t2.building_id and t1.year_month = 202402
""")
    int insertHousermaintenanceMaintenanceCostDetailed();
}
