package com.nokia.finance.tasks.pojo.po.common;

import com.baomidou.mybatisplus.annotation.TableName;
import com.nokia.finance.tasks.enums.DataStageEnum;
import lombok.Data;

import java.time.LocalDateTime;
import java.util.List;

@Data
@TableName("common.data_log")
public class DataLogPo {
    /**
     * 执行时间
     */
    private LocalDateTime createTime;

    /**
     * 数据名称
     */
    private String dataName;

    /**
     * 执行对象
     */
    private String object;

    /**
     * 操作状态
     */
    private Integer status;

    /**
     * 数据大小
     */
    private Long dataSize;

    /**
     * 数据条数
     */
    private Integer dataCount;

    /**
     * 数据环节
     */
    private String stage;

    /**
     * 操作动作
     */
    private String operationName;

    /**
     * 操作者
     */
    private String operator;

    /**
     * 操作者ip
     */
    private String operatorIp;

    /**
     * 异常信息
     */
    private String exceptionInfo;

    public DataLogPo() {
        this.createTime = LocalDateTime.now();
        this.status = 1;
        this.operator = "system";
        this.operatorIp = "172.16.107.4";
    }

    public static void addExceptionInfo(List<DataLogPo> dataLogPoList, Exception e, String dataName,
                                        DataStageEnum dataStageEnum, String operationName) {
        dataLogPoList.stream().reduce((first, second) -> second).ifPresentOrElse(t -> {
            t.setStatus(0);
            t.setExceptionInfo(e.toString());
            dataLogPoList.add(t);
        }, () -> {
            DataLogPo t = new DataLogPo();
            t.setDataName(dataName);
            t.setStage(dataStageEnum.value);
            t.setOperationName(operationName);
            t.setStatus(0);
            t.setExceptionInfo(e.toString());
            dataLogPoList.add(t);
        });
    }
}
