package com.nokia.finance.tasks.pojo.vo.car_report;

import com.nokia.finance.tasks.pojo.po.car_report.CarCqclqkPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class CarCqclqkVo {
    /**
     * 序号
     */
    private String num;
    /**
     * 单位
     */
    private String firstUnit;
    /**
     * 自有车辆小计
     */
    private String ziYou;
    /**
     * 车龄低于6年
     */
    private String lte6;
    /**
     * 车龄6-10年
     */
    private String gte6lte10;
    /**
     * 车龄10年以上
     */
    private String gt10;
    /**
     * 租赁车辆
     */
    private String zuLin;
    /**
     * 合计
     */
    private String total;
    /**
     * 成新率
     */
    private String chengXinLv;

    public CarCqclqkVo(String num, String firstUnit) {
        this.num = num;
        this.firstUnit = firstUnit;
        this.ziYou = "";
        this.lte6 = "";
        this.gte6lte10 = "";
        this.gt10 = "";
        this.zuLin = "";
        this.total = "";
        this.chengXinLv = "";
    }

    public CarCqclqkVo(Integer num, String firstUnit) {
        this.num = String.valueOf(num);
        this.firstUnit = firstUnit;
        this.ziYou = "0";
        this.lte6 = "0";
        this.gte6lte10 = "0";
        this.gt10 = "0";
        this.zuLin = "0";
        this.total = "0";
        this.chengXinLv = "0%";
    }

    public void update(CarCqclqkPo carCqclqkPo) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        DecimalFormat percentFormat = new DecimalFormat("0%");
        this.ziYou = integerFormat.format(carCqclqkPo.getZiYou());
        this.lte6 = integerFormat.format(carCqclqkPo.getLte6());
        this.gte6lte10 = integerFormat.format(carCqclqkPo.getGte6lte10());
        this.gt10 = integerFormat.format(carCqclqkPo.getGt10());
        this.zuLin = integerFormat.format(carCqclqkPo.getZuLin());
        this.total = integerFormat.format(carCqclqkPo.getTotal());
        this.chengXinLv = percentFormat.format(carCqclqkPo.getChengXinLv());
    }
}
