package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseFangWuWeiXiuZongTiQingKuangPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class HouseFwwxztqkTableVo {
    /**
     * 单位
     */
    String unit;
    /**
     * 累计维修费万元
     */
    private String tyWx;

    /**
     * 上年同期维修费万元
     */
    private String lyWx;

    /**
     * 同比增减
     */
    private String yoy;

    /**
     * 同比百分比
     */
    private String yoyPercent;

    public HouseFwwxztqkTableVo(String unit) {
        this.unit = unit;
        this.tyWx = "";
        this.lyWx = "";
        this.yoy = "";
        this.yoyPercent = "";
    }

    public void update(HouseFangWuWeiXiuZongTiQingKuangPo po) {
        DecimalFormat numberFormat = new DecimalFormat("#,##0.00");
        DecimalFormat percentFormat = new DecimalFormat("0%");
        this.tyWx = numberFormat.format(po.getTyWx());
        this.lyWx = numberFormat.format(po.getLyWx());
        this.yoy = numberFormat.format(po.getYoy());
        this.yoyPercent = percentFormat.format(po.getYoyPercent());
    }
}
