package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseBuildingStatPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class HouseZyztqkTableVo {
    /**
     * 二级组织机构名称
     */
    private String areaName;
    /**
     * 资产原值
     */
    private String zcyz;
    /**
     * 房产数量
     */
    private String fcsl;
    /**
     * 总面积
     */
    private String zmj;
    /**
     * 核心商圈
     */
    private String hxsq;
    /**
     * 一般商圈
     */
    private String ybsq;
    /**
     * 乡镇乡村
     */
    private String xzxc;

    public HouseZyztqkTableVo(String areaName) {
        this.areaName = areaName;
        this.zcyz = "";
        this.fcsl = "";
        this.zmj = "";
        this.hxsq = "";
        this.ybsq = "";
        this.xzxc = "";
    }

    public HouseZyztqkTableVo(HouseBuildingStatPo po) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        this.areaName = po.getAreaName();
        this.zcyz = integerFormat.format(po.getZcyz());
        this.fcsl = integerFormat.format(po.getFcsl());
        this.zmj = integerFormat.format(po.getZmj());
        this.hxsq = integerFormat.format(po.getHxsq());
        this.ybsq = integerFormat.format(po.getYbsq());
        this.xzxc = integerFormat.format(po.getXzxc());
    }
}
