//package com.nokia.finance.tasks.car;
//
//import com.nokia.finance.tasks.common.exception.MyRuntimeException;
//import com.nokia.finance.tasks.dao.car.CarGongCheShouFeiDao;
//import com.nokia.finance.tasks.pojo.po.common.AreaPo;
//import com.nokia.finance.tasks.pojo.po.common.OrganizationPo;
//import com.nokia.finance.tasks.service.car.CarService;
//import com.nokia.finance.tasks.service.common.AreaService;
//import com.nokia.finance.tasks.service.common.OrganizationService;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.csv.CSVFormat;
//import org.apache.commons.csv.CSVPrinter;
//import org.apache.commons.lang3.StringUtils;
//import org.apache.poi.ss.usermodel.Cell;
//import org.apache.poi.ss.usermodel.DateUtil;
//import org.apache.poi.ss.usermodel.Row;
//import org.apache.poi.ss.usermodel.Sheet;
//import org.apache.poi.ss.usermodel.Workbook;
//import org.apache.poi.xssf.usermodel.XSSFWorkbook;
//import org.junit.jupiter.api.Test;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.test.context.SpringBootTest;
//import org.springframework.test.context.ActiveProfiles;
//import org.springframework.util.CollectionUtils;
//
//import java.io.InputStream;
//import java.io.OutputStreamWriter;
//import java.math.BigDecimal;
//import java.nio.charset.StandardCharsets;
//import java.nio.file.Files;
//import java.nio.file.Path;
//import java.nio.file.Paths;
//import java.time.LocalDate;
//import java.time.LocalDateTime;
//import java.time.format.DateTimeFormatter;
//import java.util.ArrayList;
//import java.util.LinkedHashMap;
//import java.util.List;
//import java.util.Map;
//import java.util.Objects;
//import java.util.Set;
//import java.util.stream.Stream;
//
//@Slf4j
//@SpringBootTest
//@ActiveProfiles("dev")
//class CarGongCheShiYongTests1 {
//    @Autowired
//    CarService carService;
//    @Autowired
//    OrganizationService organizationService;
//    @Autowired
//    AreaService areaService;
//    @Autowired
//    CarGongCheShouFeiDao carGongCheShouFeiDao;
//
//    /**
//     * 执行任务
//     */
//    @Test
//    void runJob() {
//        // 数据目录
//        Path dir = Paths.get("test/data/che-liang-diao-du");
//        try (Stream<Path> stream = Files.list(dir)) {
//            // 获取数据目录下的文件列表
//            List<Path> pathList = stream.filter(t -> t.toString().endsWith(".xlsx")).sorted().toList();
//            log.info("数据文件列表: {}", pathList);
//            if (CollectionUtils.isEmpty(pathList)) {
//                throw new MyRuntimeException("没有文件");
//            }
//            for (Path path : pathList) {
//                singleJob(path);
//            }
//        } catch (Exception e) {
//            log.error(e.toString(), e);
//        }
//    }
//
//    /**
//     * 处理单个文件
//     *
//     * @param path 文件路径
//     */
//    public void singleJob(Path path) throws Exception {
//        List<Map<String, String>> list = readFile(path);
//        List<Map<String, String>> distinctList = dataProcessing(path, list);
//        Path csvPath = toCsv(path, distinctList);
//    }
//
//    /**
//     * 读取文件
//     *
//     * @param path 文件路径
//     */
//    public List<Map<String, String>> readFile(Path path) throws Exception {
//        Integer yearMonth = 202401;
//        List<String> staffs = carGongCheShouFeiDao.getStaffs(yearMonth);
//        log.info("读取: {}", path);
//        List<String> headers = Stream.of("pai_qian_dan_bian_hao", "shen_qing_dan_bian_hao", "che_pai_hao",
//                "shen_qing_ren", "shen_qing_dan_wei", "yong_che_ren", "yong_che_dan_wei", "mu_di_di",
//                "yong_che_ren_shu", "chu_che_shi_you", "yong_che_ren_dian_hua", "shen_qing_yong_che_shi_jian",
//                "shen_qing_fan_hui_shi_jian", "shi_ji_fan_hui_shi_jian", "diao_du_zhuang_tai", "diao_du_yuan",
//                "diao_du_shi_jian").toList();
//        try (InputStream inputStream = Files.newInputStream(path);
//             Workbook workbook = new XSSFWorkbook(inputStream)
//        ) {
//            List<Map<String, String>> resultList = new ArrayList<>();
//            // 读取第一个工作表
//            Sheet sheet = workbook.getSheetAt(0);
//            // 表头行
//            Row headerRow = sheet.getRow(0);
//            // 列数
//            int columnCount = headerRow.getPhysicalNumberOfCells();
//            log.info("columnCount: {}", columnCount);
//            // 最后行数
//            int lastRowNum = sheet.getLastRowNum();
//            log.info("lastRowNum: {}", lastRowNum);
//            if (lastRowNum == 0) {
//                throw new MyRuntimeException(path.getFileName() + " 数据0条");
//            }
//            // 遍历行
//            for (int i = 1; i <= lastRowNum; i++) {
//                Row row = sheet.getRow(i);
//                if (row == null) {
//                    continue;
//                }
//                Map<String, String> rowMap = new LinkedHashMap<>();
//                // 遍历列
//                for (int j = 0; j < columnCount; j++) {
//                    String header = headers.get(j);
//                    String cellValue = "";
//                    rowMap.put(header, cellValue);
//                    Cell cell = row.getCell(j);
//                    if (cell == null) {
//                        continue;
//                    }
//                    switch (cell.getCellType()) {
//                        case STRING:
//                            boolean skipTrim = "shen_qing_yong_che_shi_jian".equals(header)
//                                    || "shen_qing_fan_hui_shi_jian".equals(header)
//                                    || "shi_ji_fan_hui_shi_jian".equals(header)
//                                    || "diao_du_shi_jian".equals(header);
//                            // 删除字符串空白字符
//                            cellValue = skipTrim ? cell.getStringCellValue()
//                                    : org.springframework.util.StringUtils.trimAllWhitespace(cell.getStringCellValue());
//                            break;
//                        case NUMERIC:
//                            if (DateUtil.isCellDateFormatted(cell)) {
//                                cellValue = DateUtil.getLocalDateTime(cell.getNumericCellValue())
//                                        .format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//                                break;
//                            }
//                            cellValue = String.valueOf(cell.getNumericCellValue());
//                            break;
//                        case BOOLEAN:
//                            cellValue = String.valueOf(cell.getBooleanCellValue());
//                            break;
//                        default:
//                            break;
//                    }
//                    rowMap.put(headers.get(j), cellValue);
//                }
//                filter1(resultList, rowMap, staffs);
//            }
//            return resultList;
//        }
//    }
//
//    public void filter1(List<Map<String, String>> list, Map<String, String> map, List<String> staffs) {
//        String chuCheShiYou = Objects.requireNonNullElse(map.get("chu_che_shi_you"), "");
//        String muDiDi = Objects.requireNonNullElse(map.get("mu_di_di"), "");
//        String yongCheRen = Objects.requireNonNullElse(map.get("yong_che_ren"), "");
//        boolean flag = (StringUtils.containsAny(chuCheShiYou, "出差", "开会", "会议", "接站",
//                "培训", "送站", "送机", "接站", "接人")
//                && !StringUtils.containsAny(muDiDi, "政府", "市委", "委员会")
//                && !StringUtils.containsAny(chuCheShiYou, "保障"))
//                || (StringUtils.containsAny(muDiDi, "机场", "站")
//                && !StringUtils.containsAny(muDiDi, "基站", "收费站", "公交站", "加油站", "服务站",
//                "检查站", "街", "路", "检测站", "液化气站")
//                && !StringUtils.containsAny(chuCheShiYou, "政府会议", "障", "省公司", "省分", "集团",
//                "勘察", "调研", "审计", "巡视", "调测", "维护", "修", "处理", "设备", "查", "客户", "交流", "办事", "访"));
//        if (flag) {
//            for (String staff : staffs) {
//                // 用车人和用车事由包含交通补贴人员
//                if (yongCheRen.replaceAll("[^一-龥]", "").equals(staff)
//                        || chuCheShiYou.contains(staff)) {
//                    list.add(map);
//                    break;
//                }
//            }
//        }
//    }
//
//    /**
//     * 数据加工
//     *
//     * @param path 文件路径
//     * @param list 数据
//     */
//    public List<Map<String, String>> dataProcessing(Path path, List<Map<String, String>> list) {
//        Set<String> specialCar = carGongCheShouFeiDao.getSpecialCar();
//        List<OrganizationPo> secondOrgs = organizationService.getSecondOrgs();
//        List<OrganizationPo> thirdOrgs = organizationService.getThirdOrgs();
//        Map<String, OrganizationPo> orgMap = organizationService.getOrgMap(secondOrgs, thirdOrgs);
//        Map<String, List<OrganizationPo>> thirdOrganizationListMap =
//                organizationService.getThirdOrganizationListMap(secondOrgs, thirdOrgs);
//        List<AreaPo> cities = areaService.getCities();
//        List<AreaPo> districts = areaService.getDistricts();
//        Map<String, AreaPo> areaMap = areaService.getAreaMap(cities, districts);
//        Map<String, List<AreaPo>> districtListMap = areaService.getDistrictListMap(cities, districts);
//        List<Map<String, String>> resultList = new ArrayList<>();
//        for (Map<String, String> map : list) {
////            String shenQingYongCheShiJian = map.get("shen_qing_yong_che_shi_jian");
////            LocalDateTime localDateTime = LocalDateTime.parse(shenQingYongCheShiJian, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
////            String yearMonth = localDateTime.format(DateTimeFormatter.ofPattern("yyyyMM"));
////            String year = String.valueOf(localDateTime.getYear());
////            String month = String.valueOf(localDateTime.getMonthValue());
////            map.put("year_month", yearMonth);
////            map.put("year_no", year);
////            map.put("month_no", month);
//            String rawChePaiHao = map.get("che_pai_hao");
////            map.put("raw_che_pai_hao", rawChePaiHao);
//            String chePaiHao = carService.getChePai(rawChePaiHao);
//            map.put("che_pai_hao", chePaiHao);
////            String chePaiFail = carService.chePaiFail(rawChePaiHao);
////            map.put("che_pai_fail", chePaiFail);
//            String yongCheDanWei = map.get("yong_che_dan_wei");
//            String firstUnit = carService.getFirstUnit(yongCheDanWei);
//            map.put("first_unit", firstUnit);
//            String secondUnit = carService.getSecondUnit(yongCheDanWei, firstUnit);
//            map.put("second_unit", secondUnit);
//            String thirdUnit = carService.getThirdUnit(yongCheDanWei, secondUnit);
//            map.put("third_unit", thirdUnit);
////            String areaNo = carService.getAreaNo(secondOrgs, yongCheDanWei);
////            map.put("area_no", areaNo);
////            String areaName = carService.getOrgName(orgMap, areaNo);
////            map.put("area_name", areaName);
////            String cityNo = carService.getCityNo(thirdOrganizationListMap, areaNo, areaName, yongCheDanWei);
////            map.put("city_no", cityNo);
////            String cityName = carService.getOrgName(orgMap, cityNo);
////            map.put("city_name", cityName);
////            String areaNo2 = carService.getAreaNo2(areaName, cityName);
////            map.put("area_no2", areaNo2);
////            String areaName2 = carService.getOrgName(orgMap, areaNo2);
////            map.put("area_name2", areaName2);
////            String cityId = carService.getCityId(cities, yongCheDanWei);
////            map.put("city_id", cityId);
////            String city = carService.getAreaName(areaMap, cityId);
////            map.put("city", city);
////            String districtId = carService.getDistrictId(districtListMap, cityId, cityName, yongCheDanWei);
////            map.put("district_id", districtId);
////            String district = carService.getAreaName(areaMap, districtId);
////            map.put("district", district);
////            map.put("source", path.getFileName().toString());
//            filter2(resultList, map, specialCar);
//        }
//        return resultList;
//    }
//
//    public void filter2(List<Map<String, String>> list, Map<String, String> map, Set<String> specialCar) {
//        String chePaiHao = map.get("che_pai_hao");
//        if (specialCar.contains(chePaiHao)) {
//            log.info("特殊车辆: {}", chePaiHao);
//            return;
//        }
//        String shenQingYongCheShiJian = map.get("shen_qing_yong_che_shi_jian");
//        String shiJiFanHuiShiJian = map.get("shi_ji_fan_hui_shi_jian");
//        LocalDateTime startLocalDateTime = null;
//        LocalDateTime endLocalDateTime = null;
//        try {
//            startLocalDateTime = LocalDateTime.parse(shenQingYongCheShiJian,
//                    DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//            endLocalDateTime = LocalDateTime.parse(shiJiFanHuiShiJian,
//                    DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//        } catch (Exception e1) {
//            try {
//                startLocalDateTime = LocalDate.parse(shenQingYongCheShiJian,
//                        DateTimeFormatter.ofPattern("yyyy-MM-dd")).atStartOfDay();
//                endLocalDateTime = LocalDate.parse(shiJiFanHuiShiJian,
//                        DateTimeFormatter.ofPattern("yyyy-MM-dd")).atStartOfDay();
//            } catch (Exception e2) {
//                log.error("时间格式化失败: {} -> {}", shenQingYongCheShiJian, shiJiFanHuiShiJian);
//            }
//        }
//        if (endLocalDateTime == null) {
//            endLocalDateTime = startLocalDateTime;
//        }
//        // 查询行驶里程
//        BigDecimal liCheng = carGongCheShouFeiDao.getCarLiChengDayByChePaiAndDate(chePaiHao,
//                startLocalDateTime.toLocalDate(), endLocalDateTime.toLocalDate());
////        if (liCheng == null) {
////            return;
////        }
////        if (liCheng.compareTo(BigDecimal.ZERO) == 0 || liCheng.compareTo(new BigDecimal("20")) > 0) {
////            return;
////        }
////        if (liCheng != null && liCheng.compareTo(new BigDecimal("20")) > 0) {
////            return;
////        }
//        map.put("li_cheng", liCheng == null ? null : liCheng.toString());
//        list.add(map);
//    }
//
//    /**
//     * 生成csv
//     *
//     * @param path 源文件路径
//     * @param list 数据
//     */
//    public Path toCsv(Path path, List<Map<String, String>> list) throws Exception {
//        log.info("条数：{}", list.size());
//        Files.createDirectories(Paths.get("test/history/"));
//        Path csvPath = Paths.get("test/history/" + path.getFileName() + ".csv");
//        try (OutputStreamWriter osw = new OutputStreamWriter(Files.newOutputStream(csvPath),
//                StandardCharsets.UTF_8);
//             CSVPrinter printer = new CSVPrinter(osw, CSVFormat.DEFAULT)) {
//            // 添加bom头避免excel乱码
//            osw.write('\ufeff');
////            Map<String, String> header = list.get(0);
////            // 表头
////            printer.printRecord(header.keySet());
//            printer.printRecord("派遣单编号","申请单编号","车牌号","申请人","申请单位","用车人","用车单位","目的地","用车人数","出车事由","用车人电话","申请用车时间","申请返回时间","实际返回时间","调度状态","调度员","调度时间", "用车单位一级", "用车单位二级", "用车单位三级", "日里程");
//            for (Map<String, String> map : list) {
//                printer.printRecord(map.values());
//            }
//        }
//        return csvPath;
//    }
//}
