//package com.nokia.finance.tasks.car;
//
//import com.google.gson.Gson;
//import com.google.gson.reflect.TypeToken;
//import com.nokia.finance.tasks.common.exception.MyRuntimeException;
//import com.nokia.finance.tasks.dao.car.CarGongCheShouFeiDao;
//import com.nokia.finance.tasks.pojo.po.common.AreaPo;
//import com.nokia.finance.tasks.pojo.po.common.OrganizationPo;
//import com.nokia.finance.tasks.service.car.CarService;
//import com.nokia.finance.tasks.service.common.AreaService;
//import com.nokia.finance.tasks.service.common.OrganizationService;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.csv.CSVFormat;
//import org.apache.commons.csv.CSVPrinter;
//import org.apache.commons.lang3.StringUtils;
//import org.apache.poi.ss.usermodel.Cell;
//import org.apache.poi.ss.usermodel.DateUtil;
//import org.apache.poi.ss.usermodel.Row;
//import org.apache.poi.ss.usermodel.Sheet;
//import org.apache.poi.ss.usermodel.Workbook;
//import org.apache.poi.xssf.usermodel.XSSFWorkbook;
//import org.junit.jupiter.api.Test;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.test.context.SpringBootTest;
//import org.springframework.test.context.ActiveProfiles;
//import org.springframework.util.CollectionUtils;
//
//import java.io.InputStream;
//import java.io.OutputStreamWriter;
//import java.math.BigDecimal;
//import java.nio.charset.StandardCharsets;
//import java.nio.file.Files;
//import java.nio.file.Path;
//import java.nio.file.Paths;
//import java.time.LocalDate;
//import java.time.LocalDateTime;
//import java.time.format.DateTimeFormatter;
//import java.util.ArrayList;
//import java.util.LinkedHashMap;
//import java.util.List;
//import java.util.Map;
//import java.util.Objects;
//import java.util.Set;
//import java.util.stream.Stream;
//
//@Slf4j
//@SpringBootTest
//@ActiveProfiles("dev")
//class CarGongCheShiYongTests2 {
//    @Autowired
//    CarService carService;
//    @Autowired
//    OrganizationService organizationService;
//    @Autowired
//    AreaService areaService;
//    @Autowired
//    CarGongCheShouFeiDao carGongCheShouFeiDao;
//
//    /**
//     * 执行任务
//     */
//    @Test
//    void runJob() {
//        // 数据目录
//        Path dir = Paths.get("test/data/ycxxzl");
//        try (Stream<Path> stream = Files.list(dir)) {
//            // 获取数据目录下的文件列表
//            List<Path> pathList = stream.filter(t -> t.toString().endsWith(".xlsx")).sorted().toList();
//            log.info("数据文件列表: {}", pathList);
//            if (CollectionUtils.isEmpty(pathList)) {
//                throw new MyRuntimeException("没有文件");
//            }
//            for (Path path : pathList) {
//                singleJob(path);
//            }
//        } catch (Exception e) {
//            log.error(e.toString(), e);
//        }
//    }
//
//    /**
//     * 处理单个文件
//     *
//     * @param path 文件路径
//     */
//    public void singleJob(Path path) throws Exception {
//        List<Map<String, String>> list = readFile(path);
//        List<Map<String, String>> distinctList = dataProcessing(path, list);
//        Path csvPath = toCsv(path, distinctList);
//    }
//
//    /**
//     * 读取文件
//     *
//     * @param path 文件路径
//     */
//    public List<Map<String, String>> readFile(Path path) throws Exception {
//        log.info("读取: {}", path);
//        try (InputStream inputStream = Files.newInputStream(path);
//             Workbook workbook = new XSSFWorkbook(inputStream)
//        ) {
//            List<Map<String, String>> resultList = new ArrayList<>();
//            // 读取第一个工作表
//            Sheet sheet = workbook.getSheetAt(0);
//            // 最后行数
//            int lastRowNum = sheet.getLastRowNum();
//            log.info("lastRowNum: {}", lastRowNum);
//            if (lastRowNum == 0) {
//                throw new MyRuntimeException(path.getFileName() + " 数据0条");
//            }
//            Gson gson = new Gson();
//            int currentRowNum = 0;
//            while (currentRowNum <= lastRowNum) {
//                log.info(">>>>>>>>>>currentRowNum: {}", currentRowNum);
//                Map<String, String> rowMap = new LinkedHashMap<>();
//                // 申请单表头行
//                Row row1 = sheet.getRow(currentRowNum);
//                // 申请单数据行
//                Row row2 = sheet.getRow(++currentRowNum);
//                if (currentRowNum > lastRowNum) {
//                    break;
//                }
//                List<String> headers1;
//                int lastCellNum1 = row1.getLastCellNum();
//                headers1 = switch (lastCellNum1) {
//                    case 9 ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_qing_shi_jian").toList();
//                    case 13 ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_qing_shi_jian").toList();
//                    case 17 ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_pi_ren2", "shen_pi_jie_guo2", "shen_pi_shi_jian2", "shen_pi_yi_jian2", "shen_qing_shi_jian").toList();
//                    default ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_pi_ren2", "shen_pi_jie_guo2", "shen_pi_shi_jian2", "shen_pi_yi_jian2", "shen_pi_ren3", "shen_pi_jie_guo3", "shen_pi_shi_jian3", "shen_pi_yi_jian3", "shen_qing_shi_jian").toList();
//                };
//
//                int headerSize1 = headers1.size();
//                for (int i = 0; i < headerSize1; i++) {
//                    String header = headers1.get(i);
//                    Cell cell = row2.getCell(i);
//                    String cellValue = "";
//                    switch (cell.getCellType()) {
//                        case STRING:
//                            boolean skipTrim = "shen_qing_shi_jian".equals(header)
//                                    || "shen_pi_shi_jian1".equals(header)
//                                    || "shen_pi_shi_jian2".equals(header)
//                                    || "shen_pi_shi_jian3".equals(header);
//                            // 删除字符串空白字符
//                            cellValue = skipTrim ? cell.getStringCellValue()
//                                    : org.springframework.util.StringUtils.trimAllWhitespace(cell.getStringCellValue());
//                            break;
//                        case NUMERIC:
//                            if (DateUtil.isCellDateFormatted(cell)) {
//                                cellValue = DateUtil.getLocalDateTime(cell.getNumericCellValue())
//                                        .format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//                                break;
//                            }
//                            cellValue = String.valueOf(cell.getNumericCellValue());
//                            break;
//                        case BOOLEAN:
//                            cellValue = String.valueOf(cell.getBooleanCellValue());
//                            break;
//                        default:
//                            break;
//                    }
//                    rowMap.put(header, cellValue);
//                }
//                ++currentRowNum;
//                if (currentRowNum > lastRowNum) {
//                    filter1(resultList, rowMap);
//                    break;
//                }
//                if (!"派遣单编号".equals(sheet.getRow(currentRowNum).getCell(0).getStringCellValue())) {
//                    filter1(resultList, rowMap);
//                    continue;
//                }
//
//                while (currentRowNum <= lastRowNum) {
//                    Map<String, String> rowMapCopy = gson.fromJson(gson.toJson(rowMap), new TypeToken<>() {});
//                    // 派遣单表头行
//                    Row row3 = sheet.getRow(currentRowNum);
//                    if (!"派遣单编号".equals(row3.getCell(0).getStringCellValue())) {
//                        break;
//                    }
//                    Row row4 = sheet.getRow(++currentRowNum);
//                    if (currentRowNum > lastRowNum) {
//                        break;
//                    }
//                    List<String> headers2 = Stream.of("pai_qian_dan_bian_hao", "che_pai_hao", "jia_shi_yuan", "chu_che_shi_jian", "gui_dui_shi_jian", "pai_qian_che_liang_zhuang_tai", "ren_wu_zhi_xing_zhuang_tai").toList();
//                    int headersSize2 = headers2.size();
//                    for (int i = 0; i < headersSize2; i++) {
//                        String header = headers2.get(i);
//                        Cell cell = row4.getCell(i);
//                        String cellValue = "";
//                        switch (cell.getCellType()) {
//                            case STRING:
//                                boolean skipTrim = "chu_che_shi_jian".equals(header)
//                                        || "gui_dui_shi_jian".equals(header);
//                                // 删除字符串空白字符
//                                cellValue = skipTrim ? cell.getStringCellValue()
//                                        : org.springframework.util.StringUtils.trimAllWhitespace(cell.getStringCellValue());
//                                break;
//                            case NUMERIC:
//                                if (DateUtil.isCellDateFormatted(cell)) {
//                                    cellValue = DateUtil.getLocalDateTime(cell.getNumericCellValue())
//                                            .format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//                                    break;
//                                }
//                                cellValue = String.valueOf(cell.getNumericCellValue());
//                                break;
//                            case BOOLEAN:
//                                cellValue = String.valueOf(cell.getBooleanCellValue());
//                                break;
//                            default:
//                                break;
//                        }
//                        rowMapCopy.put(header, cellValue);
//                    }
//                    filter1(resultList, rowMapCopy);
//                    currentRowNum++;
//                }
//            }
//            return resultList;
//        }
//    }
//
//    public void filter1(List<Map<String, String>> list, Map<String, String> map) {
//        String shenQingDanZhuangTai = map.get("shen_qing_dan_zhuang_tai");
//        if (!"已完成".equals(shenQingDanZhuangTai)) {
//            return;
//        }
//        String yongCheShiYou = Objects.requireNonNullElse(map.get("yong_che_shi_you"), "");
//        boolean flag = StringUtils.containsAny(yongCheShiYou, "出差", "开会", "会议", "接站",
//                "培训", "送站", "送机", "接站", "接人", "机场", "站")
//                && !StringUtils.containsAny(yongCheShiYou, "障", "营销", "查", "物料", "省公司",
//                "省分", "集团", "勘察", "调研", "审计", "巡视", "调测", "维护", "修", "处理", "设备", "客户", "交流", "办事",
//                "访", "政府", "市委", "委员会", "县委", "基站", "收费站", "公交站", "加油站", "服务站", "检查站", "街", "路",
//                "检测站", "液化气站", "总部");
//        if (flag) {
//            list.add(map);
//        }
//    }
//
//    /**
//     * 数据加工
//     *
//     * @param path 文件路径
//     * @param list 数据
//     */
//    public List<Map<String, String>> dataProcessing(Path path, List<Map<String, String>> list) {
//        Integer yearMonth = 202402;
//        List<Map<String, String>> staffs = carGongCheShouFeiDao.getStaffs(yearMonth);
//        Set<String> specialCar = carGongCheShouFeiDao.getSpecialCar();
//        List<OrganizationPo> secondOrgs = organizationService.getSecondOrgs();
//        List<OrganizationPo> thirdOrgs = organizationService.getThirdOrgs();
//        Map<String, OrganizationPo> orgMap = organizationService.getOrgMap(secondOrgs, thirdOrgs);
//        Map<String, List<OrganizationPo>> thirdOrganizationListMap =
//                organizationService.getThirdOrganizationListMap(secondOrgs, thirdOrgs);
//        List<AreaPo> cities = areaService.getCities();
//        List<AreaPo> districts = areaService.getDistricts();
//        Map<String, AreaPo> areaMap = areaService.getAreaMap(cities, districts);
//        Map<String, List<AreaPo>> districtListMap = areaService.getDistrictListMap(cities, districts);
//        List<Map<String, String>> resultList = new ArrayList<>();
//        for (Map<String, String> map : list) {
////            String shenQingYongCheShiJian = map.get("shen_qing_yong_che_shi_jian");
////            LocalDateTime localDateTime = LocalDateTime.parse(shenQingYongCheShiJian, DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
////            String yearMonth = localDateTime.format(DateTimeFormatter.ofPattern("yyyyMM"));
////            String year = String.valueOf(localDateTime.getYear());
////            String month = String.valueOf(localDateTime.getMonthValue());
////            map.put("year_month", yearMonth);
////            map.put("year_no", year);
////            map.put("month_no", month);
//            String rawChePaiHao = map.get("che_pai_hao");
////            map.put("raw_che_pai_hao", rawChePaiHao);
//            String chePaiHao = carService.getChePai(rawChePaiHao);
//            map.put("che_pai_hao", chePaiHao);
////            String chePaiFail = carService.chePaiFail(rawChePaiHao);
////            map.put("che_pai_fail", chePaiFail);
//            String yongCheRenDanWei = map.get("yong_che_ren_dan_wei");
//            String firstUnit = carService.getFirstUnit(yongCheRenDanWei);
//            map.put("first_unit", firstUnit);
//            String secondUnit = carService.getSecondUnit(yongCheRenDanWei, firstUnit);
//            map.put("second_unit", secondUnit);
//            String thirdUnit = carService.getThirdUnit(yongCheRenDanWei, secondUnit);
//            map.put("third_unit", thirdUnit);
////            String areaNo = carService.getAreaNo(secondOrgs, yongCheDanWei);
////            map.put("area_no", areaNo);
////            String areaName = carService.getOrgName(orgMap, areaNo);
////            map.put("area_name", areaName);
////            String cityNo = carService.getCityNo(thirdOrganizationListMap, areaNo, areaName, yongCheDanWei);
////            map.put("city_no", cityNo);
////            String cityName = carService.getOrgName(orgMap, cityNo);
////            map.put("city_name", cityName);
////            String areaNo2 = carService.getAreaNo2(areaName, cityName);
////            map.put("area_no2", areaNo2);
////            String areaName2 = carService.getOrgName(orgMap, areaNo2);
////            map.put("area_name2", areaName2);
////            String cityId = carService.getCityId(cities, yongCheDanWei);
////            map.put("city_id", cityId);
////            String city = carService.getAreaName(areaMap, cityId);
////            map.put("city", city);
////            String districtId = carService.getDistrictId(districtListMap, cityId, cityName, yongCheDanWei);
////            map.put("district_id", districtId);
////            String district = carService.getAreaName(areaMap, districtId);
////            map.put("district", district);
////            map.put("source", path.getFileName().toString());
//            filter2(resultList, map, specialCar, staffs);
//        }
//        return resultList;
//    }
//
//    public void filter2(List<Map<String, String>> list, Map<String, String> map, Set<String> specialCar,
//                        List<Map<String, String>> staffs) {
//        String yongCheShiYou = Objects.requireNonNullElse(map.get("yong_che_shi_you"), "");
//        String yongCheRen = Objects.requireNonNullElse(map.get("yong_che_ren"), "");
//        String chePaiHao = map.get("che_pai_hao");
//        String shenQingShiJian = map.get("shen_qing_shi_jian");
//        String chuCheShiJian = map.get("chu_che_shi_jian");
//        String guiDuiShiJian = map.get("gui_dui_shi_jian");
//        String firstUnit1 = Objects.requireNonNullElse(map.get("first_unit"), "");
//        boolean notInStaffs = true;
//        for (Map<String, String> staff : staffs) {
//            String firstUnit2 = staff.get("first_unit");
//            String xingMing = staff.get("xing_ming");
//            // 用车人或用车事由包含交通补贴人员且单位相同
//            if (firstUnit1.equals(firstUnit2)
//                    && (yongCheRen.replaceAll("[^一-龥]", "").equals(xingMing)
//                    || yongCheShiYou.contains(xingMing))) {
//                notInStaffs = false;
//                break;
//            }
//        }
//        if (notInStaffs) {
//            return;
//        }
//        if (StringUtils.isBlank(chePaiHao)) {
//            list.add(map);
//            return;
//        }
//        if (specialCar.contains(chePaiHao)) {
//            log.info("特殊车辆: {}", chePaiHao);
//            return;
//        }
//        if (StringUtils.isBlank(chuCheShiJian)) {
//            chuCheShiJian = shenQingShiJian;
//        }
//        if (StringUtils.isBlank(guiDuiShiJian)) {
//            guiDuiShiJian = chuCheShiJian;
//        }
//        LocalDateTime startLocalDateTime = null;
//        LocalDateTime endLocalDateTime = null;
//        try {
//            startLocalDateTime = LocalDateTime.parse(chuCheShiJian,
//                    DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//        } catch (Exception e1) {
//            try {
//                startLocalDateTime = LocalDate.parse(chuCheShiJian,
//                        DateTimeFormatter.ofPattern("yyyy-MM-dd")).atStartOfDay();
//            } catch (Exception e2) {
//                log.error("时间格式化失败: {}", chuCheShiJian);
//            }
//        }
//        try {
//            endLocalDateTime = LocalDateTime.parse(guiDuiShiJian,
//                    DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//        } catch (Exception e1) {
//            try {
//                endLocalDateTime = LocalDate.parse(guiDuiShiJian,
//                        DateTimeFormatter.ofPattern("yyyy-MM-dd")).atStartOfDay();
//            } catch (Exception e2) {
//                log.error("时间格式化失败: {}", guiDuiShiJian);
//            }
//        }
//        // 查询行驶里程
//        BigDecimal liCheng = carGongCheShouFeiDao.getCarLiChengDayByChePaiAndDate(chePaiHao,
//                startLocalDateTime.toLocalDate(), endLocalDateTime.toLocalDate());
//        map.put("li_cheng", liCheng == null ? null : liCheng.toString());
//        list.add(map);
//    }
//
//    /**
//     * 生成csv
//     *
//     * @param path 源文件路径
//     * @param list 数据
//     */
//    public Path toCsv(Path path, List<Map<String, String>> list) throws Exception {
//        log.info("条数：{}", list.size());
//        Files.createDirectories(Paths.get("test/history/"));
//        Path csvPath = Paths.get("test/history/" + path.getFileName() + ".csv");
//        try (OutputStreamWriter osw = new OutputStreamWriter(Files.newOutputStream(csvPath),
//                StandardCharsets.UTF_8);
//             CSVPrinter printer = new CSVPrinter(osw, CSVFormat.DEFAULT)) {
//            // 添加bom头避免excel乱码
//            osw.write('\ufeff');
////            Map<String, String> header = list.get(0);
////            // 表头
////            printer.printRecord(header.keySet());
//            printer.printRecord("申请单号","申请人","申请人单位","申请类型","用车人","用车人单位","用车事由","申请单状态","申请时间","审批人1","审批结果1","审批时间1","审批意见1","审批人2","审批结果2","审批时间2","审批意见2","审批人3","审批结果3","审批时间3","审批意见3","派遣单编号","车牌号码","驾驶员","出车时间","归队时间","派遣车辆状态","任务执行状态", "用车单位一级", "用车单位二级", "用车单位三级", "里程");
//            for (Map<String, String> map : list) {
//                printer.printRecord(
//                        map.get("shen_qing_dan_hao"),
//                        map.get("shen_qing_ren"),
//                        map.get("shen_qing_ren_dan_wei"),
//                        map.get("shen_qing_lei_xing"),
//                        map.get("yong_che_ren"),
//                        map.get("yong_che_ren_dan_wei"),
//                        map.get("yong_che_shi_you"),
//                        map.get("shen_qing_dan_zhuang_tai"),
//                        map.get("shen_qing_shi_jian"),
//                        map.get("shen_pi_ren1"),
//                        map.get("shen_pi_jie_guo1"),
//                        map.get("shen_pi_shi_jian1"),
//                        map.get("shen_pi_yi_jian1"),
//                        map.get("shen_pi_ren2"),
//                        map.get("shen_pi_jie_guo2"),
//                        map.get("shen_pi_shi_jian2"),
//                        map.get("shen_pi_yi_jian2"),
//                        map.get("shen_pi_ren3"),
//                        map.get("shen_pi_jie_guo3"),
//                        map.get("shen_pi_shi_jian3"),
//                        map.get("shen_pi_yi_jian3"),
//                        map.get("pai_qian_dan_bian_hao"),
//                        map.get("che_pai_hao"),
//                        map.get("jia_shi_yuan"),
//                        map.get("chu_che_shi_jian"),
//                        map.get("gui_dui_shi_jian"),
//                        map.get("pai_qian_che_liang_zhuang_tai"),
//                        map.get("ren_wu_zhi_xing_zhuang_tai"),
//                        map.get("first_unit"),
//                        map.get("second_unit"),
//                        map.get("third_unit"),
//                        map.get("li_cheng")
//                );
//            }
//        }
//        return csvPath;
//    }
//}
